%
% This file is a simple example for classifition of the Pen-Based Recognition
% of Handwritten Digits Database (PenDigits Database). Precisely, this file
% yields accuracies of the classifiers  based on PAMMs and their compositions, 
% as well as the classifiers based on the original AMMs. The PenDigits 
% Database is available for download at UCI  repository.
% You shall download the 10-fold partition of the KEEL-dataset repository,
% if you want to reproduce the computational experiments of the paper entitled 
% ''Max-plus and Min-plus Projection Autoassociative Morphological Memories and 
% Their Compositions for Pattern Recognition'', which have been submitted to 
% Neural Networks. The expected accuracies are:
%
% Hxx = 96.369
% Gxx = 96.598
% Mxx = 82.476
% Wxx = 82.476
% Rxx = 96.169
% Pxx = 96.341
% Bxx = 95.998
% Axx = 95.197
%

clear all

load('PenDigits_Dataset.mat');

tic
% Select a PAMM model from the list: Wxx, Mxx, Axx, Bxx, Gxx, Hxx, Pxx, or Rxx;
PAMM = 'Gxx';
% Classify the dada using the PAMM mode;
z = PAMMclassify(PAMM,Xtrain,LabelTrain,Xteste);
% Compute the accuracy;
Accuracy=100*mean(TestLabel==z)
toc
