% Examples 1, 2 and 4 of the papper entitled ''Max-plus and Min-plus Projection Autoassociative 
%    Morphological Memories and Their Compositions for Pattern Recognition'', submited for publication to
%    Neural Network:
% 

format short

%
% Load the matriz whose columns are the fundamental memories.
% 
X=[2 8 1;
 8 4 8;
 2 6 3;
 8 7 3;
 1 2 7;
 7 5 5;
 9 5 10];
 
%
% Define the input vector which can be viewed as a corrupted version of the fundamental memory x1.
%
x=[-2; 8; -1; 8; 1; 7; 12];

%
% Example 1;
% Apply the original original AMMs of Ritter and Sussner on the input vector x.
%
yM=Mxx(X,x)'
yW=Wxx(X,x)'

%
% Example 2 and 4;
% Apply the PAMMs and their compositions on the input vector x.
%
yA=Axx(X,x)' 
yB=Bxx(X,x)' 

yH=Hxx(X,x)' 
yP=Pxx(X,x)' 

yR=Rxx(X,x)' 
yG=Gxx(X,x)' 

%
% Compute the normalized mean squared error between x1 and the output of the memory models
%
NMSE_Mxx=norm(yM'-X(:,1))^2/norm(X(:,1))^2
NMSE_Wxx=norm(yW'-X(:,1))^2/norm(X(:,1))^2

NMSE_Axx=norm(yA'-X(:,1))^2/norm(X(:,1))^2
NMSE_Bxx=norm(yB'-X(:,1))^2/norm(X(:,1))^2

NMSE_Rxx=norm(yR'-X(:,1))^2/norm(X(:,1))^2
NMSE_Pxx=norm(yP'-X(:,1))^2/norm(X(:,1))^2

NMSE_Hxx=norm(yH'-X(:,1))^2/norm(X(:,1))^2
NMSE_Gxx=norm(yG'-X(:,1))^2/norm(X(:,1))^2
