function z = PAMMclassify(PAMM,Xtrain,LabelTrain,Xtest)

% Get the class labels;
ClassLabel=unique(LabelTrain);

for i=1:length(ClassLabel)
	% Find all the training vectors of the ith class;
	ind=find(LabelTrain==ClassLabel(i));
	% Compute the vectors retrieved by the PAMM memory trained using vectos from the ith class;
	Y=feval(PAMM,Xtrain(:,ind),Xtest);
	% Compute the Chebyshev distance between the input and retrieved vectors;
	D(i,:)=max(abs(Y-Xtest));
end

% Determine the index that yields the minimum Chebyshev distance;
[value,ind]=min(D);
% Assing the class label to the indexes obtained;
z=ClassLabel(ind);
