function y=Rxx(X,x)
%
% This function implements projection autoassociative morphological memor given by the composition Rxx = Bxx Axx.
%
% Usage:
% >> y=Rxx(X,x)
%
% Arguments:
% - X is a matrix whose columns correspond to the fundamental memories.
% - x is the input pattern. Here, x can be a matrix with k columns. In this case, the output is also
%         a matrix with the corresponding recalled patterns as columns.
%
% Returns:
% - y is the vector retrieved by the maxplus PAMM.
%

% Copyright (c) 2017 Alex S. Santos and Marcos E. Valle.
% University of Campinas
% Institute of Mathematics, Statistics, and Scientific Computing (IMECC)
% www.ime.unicamp.br/~valle/Codes/PAMMs.zip
% 
% Permission is hereby granted, free of charge, to any person obtaining a copy
% of this software and associated documentation files (the "Software"), to deal
% in the Software without restriction, subject to the following conditions:
% 
% The above copyright notice and this permission notice shall be included in 
% all copies or substantial portions of the Software.
%
% The Software is provided "as is", without warranty of any kind.
%
% December 2017
%

y=Bxx(X,Axx(X,x));
