#include "mex.h"

void mexFunction(int nlhs, mxArray *plhs[], 
    int nrhs, const mxArray *prhs[])

{
 double aux;
 int M, N, K;
 if (nrhs != 2)
 	mexErrMsgTxt("The number of input arguments must be two.");

 /* Find the dimensions of the input matrices; */
 M = mxGetM(prhs[0]);
 K = mxGetN(prhs[0]);
 N = mxGetN(prhs[1]);
 
 if (K != mxGetM(prhs[1]))
	mexErrMsgTxt("Error: Inner matrix dimensions must agree.");
 
 /* Create an mxArray for the output data */
 plhs[0] = mxCreateDoubleMatrix(M, N, mxREAL);

 int i,j,l;
 double *A, *B, *C;

 /* Retrieve the input data */
 A = mxGetPr(prhs[0]);
 B = mxGetPr(prhs[1]);

 /* Create a pointer to the output data */
 C = mxGetPr(plhs[0]);

 /* Put data in the output array */
 for (j=0; j<N; j++)
	for (i=0; i<M; i++)
	{
		C[M*j+i]=A[i]+B[K*j];
		for (l=0; l<K; l++)
		{
			aux=A[M*l+i]+B[K*j+l];
			if (C[M*j+i] < aux)
				C[M*j+i] = aux;
		} 
	}
}
